ad_page_contract {

    @author Andrew Grumet <aegrumet@arsdigita.com>
    @cvs-id: $Id: folder-ae-2.tcl,v 1.8 2001/02/27 02:32:36 aegrumet Exp $

    If folder_id is passed in, update that folder.
    Otherwise, add a new folder.

} {
    return_url:notnull
    title:notnull
    descr:optional
    exp_date:array,date
    default_prefix:optional
    folder_id:optional,naturalnum
}

ad_maybe_redirect_for_registration

set caller_id [ad_conn user_id]
set caller_ip [ns_conn peeraddr]
set package_id [ad_conn package_id]

if ![info exists descr] {
    set descr [db_null]
}

if [empty_string_p $exp_date(year)] {
    set default_exp_date [db_null]
} else {
    set default_exp_date "$exp_date(year)-$exp_date(month)-$exp_date(day)"
}

if [empty_string_p default_prefix] {
    set default_prefix [db_null]
} else {
    set default_prefix [pl_photo_cleanup_filename $default_prefix]
}

if [info exists folder_id] {
    #check permissions
    ad_require_permission $folder_id admin

    db_dml pl_folder_update {
	update pl_folders
	set title = :title,
            descr = :descr,
            default_exp_date = :default_exp_date,
            default_prefix = :default_prefix
        where folder_id in (:folder_id)
    }
} else {
    db_exec_plsql pl_folder_create "
declare
  v_folder_id integer;
begin
  v_folder_id := pl_folder.new (
    title             => :title,
    descr             => :descr,
    default_exp_date  => :default_exp_date,
    default_prefix    => :default_prefix,
    creation_user     => :caller_id,
    creation_ip       => :caller_ip,
    context_id        => :package_id );
end;
"
}

ad_returnredirect $return_url
